//+------------------------------------------------------------------+
//|                                           Profit Double Long.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//#include <stderror.mqh>
//#include <stdlib.mqh>
//----------------------------------------------------------------------------
extern string  INITIAL_PARAMETERS         = "INITIAL PARAMETERS"; //Init Parameters
extern int     MagicNumber                = 11111;                // g_magic_208      Magic          (Identification number appropriated to deals of this robot - That it would not be confused to deals of other robots)
extern double  MaxiumSpread               = 4.0;                  // (4.0)            MaxSpread        (If spread will exceed the given restriction - That commerce will be suspended for protection against risks (It is not involved in the given version)) (Spread - The maximal difference between the prices: purchases (Bid)and sales (Ask))
extern int     Slippage                   = 5;                    // g_slippage_96    Slippage           
string The_Comment                        = "Profit Gainer ";      // Expret_Comment        (In a window the Terminal - inset Commerce (And in the others tabs) - Right on empty seat of a window - 
//==================================================================================
extern string  PARAMETERS_LOT             = "PARAMETERS LOT";     // Parameters Lot
extern int     Lot_Type_0_1_2             = 2;                    // gd_112           Lotdecimal
extern double  Lot                        = 0.01;                 // (0.1)            Lots
extern double  LotExponent                = 1.44;                 // gd_88            LotExponent
//==================================================================================
extern string  INPUT_PARAMETERS           = "PARAMETERS OF THE INPUT"; // Input Parameters
extern int     Max_Trades                 = 1000;                 // MaxTrades 
extern int     Pip_Step                   = 4;                    // g_pips_152   Pip Step
//==================================================================================
extern string  OUTPUT_PARAMETERS          = "PARAMETERS OF THE OUTPUT"; // Output Parameters
extern int     TakeProfit                 = 1;                   // g_pips_120
//==================================================================================
extern string  INPUT_FILTERS              = "FILTERS OF THE INPUT"; // Input Filters
extern bool    UseHourTrade               = FALSE;                // UseHourTrade     UseHourTrade
extern int     StartHour                  = 16;                   // StartHour (0)    StartHour
extern int     EndHour                    = 2;                    // EndHour   (8)    EndHour
//==================================================================================
extern string  OUTPUT_FILTERS             = "FILTERS OF THE OUTPUT";     // Output Filters
extern bool    Equity_Stop                = FALSE;                // gi_164           UseEquityStop
extern double  Equity_Risk                = 20.0;                 // gd_168           TotalEquityRisk
extern bool    TimeOut                    = FALSE;                // gi_180           UseTimeOut
extern double  Timeout_hours              = 0.0;                  // gd_184  (30.0)   MaxTradeOpenHours
//==================================================================================
bool  HourTrade_2  =  FALSE;   // UseHourTrade2    UseHourTrade2
bool  Close_On_Filters  =  FALSE; // gi_80            UseClose
//==================================================================================
bool  Multiplication_Lot   =  TRUE; // gi_84            UseAdd
int   Type_Average_lot     =  1; // gi_76            MMType
//==================================================================================
int   StopLoss             =  0; // g_pips_128       Stoploss
//==================================================================================
double gd_220;
double gd_268;
double gd_276;
double gd_316;
double gd_332 = 0.0;
double gd_368;
double gd_376;
//------------------------------
double gd_unused_228;
double gd_unused_236;
//------------------------------
bool   gi_292;
int    gi_308;
int    gi_312 = 0;
int    gi_328;
bool   gi_340 = FALSE;
bool   gi_344 = FALSE;
bool   gi_348 = FALSE;
int    gi_352;
bool   gi_356 = FALSE;
//------------------------------
double g_ask_260;
//------------------------------
double g_bid_252;
//------------------------------
int    g_datetime_360 = 0;
int    g_datetime_364 = 0;
//------------------------------
int    g_pos_324 = 0;
//------------------------------
double g_price_212;
double g_price_244;
//------------------------------
int    g_time_304 = 0;
//------------------------------
int    gi_222           =     1;
//------------------------------
string gs_140 = "lblfin_";
//==================================================================================================================================
int init() {
   if (IsTesting() ==  TRUE) Display_Info();
   if (IsTesting() == FALSE) Display_Info();
   double step    = MarketInfo(Symbol(), MODE_LOTSTEP);
   switch(step) {
      case 0.01 : Lot_Type_0_1_2 = 2; break;
      case  0.1 : Lot_Type_0_1_2 = 1; break;
      case    1 : Lot_Type_0_1_2 = 0; break;
   }
   if (Digits == 5 || Digits == 3) gi_222 = 10; // Check on a five-sign
    return (0);
}
//==================================================================================================================================
int deinit() {
   return (0);
}
//==================================================================================================================================
int start() {
   Display_Info(); 
//-------------------------------
   double ld_84;
//-------------------------------
   double ord_lots_500;
   double ord_lots_508;
   double iclose_516;
   double iclose_524;
//-------------------------------
   DrawStats();
//-------------------------------
   if (Digits <= 3) ld_84 = 0.01;
   else   ld_84  = 0.0001;
   double ld_92  = NormalizeDouble((Ask - Bid) / ld_84, 1);
   string ls_100 = "  OK";
   if (ld_92 > MaxiumSpread) ls_100 = " TOO HIGH !";
   string ls_124 = "Spread = " + DoubleToStr(ld_92, 1);
   string ls_140 = ls_100;
   //==================================================================================================================================
  
   ObjectCreate ("klc19", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("klc19", "Spread: " + DoubleToStr(ld_92, 1) + ls_140, 12, "Tahoma", Yellow);
   ObjectSet    ("klc19", OBJPROP_CORNER, 3);
   ObjectSet    ("klc19", OBJPROP_XDISTANCE,  10);
   ObjectSet    ("klc19", OBJPROP_YDISTANCE, 10);

//==================================================================================================================================
if (HourTrade_2) {
      if (!(Hour() >= StartHour && Hour() <= EndHour)) {
         CloseThisSymbolAll();
         Comment("                              TIME FOR TRADE STILL HAS NOT COME!");
         return (0);
      }
   }
   string ls_532 = "false";
   string ls_540 = "false";
   if (UseHourTrade == FALSE || (UseHourTrade && (EndHour > StartHour && (Hour() >= StartHour && Hour() <= EndHour)) || (StartHour > EndHour && (!(Hour() >= EndHour && Hour() <= StartHour))))) ls_532 = "true";
   if (UseHourTrade && (EndHour > StartHour && (!(Hour() >= StartHour && Hour() <= EndHour))) || (StartHour > EndHour && (Hour() >= EndHour && Hour() <= StartHour))) ls_540 = "true";
   if (TimeOut) {
      if (TimeCurrent() >= gi_308) {
         CloseThisSymbolAll();
         Print("Trades will be closed because of the Time-out");
      }
   }
   if (g_time_304 == Time[0]) return (0);
   g_time_304 = Time[0];
   double ld_548 = CalculateProfit();
   if (Equity_Stop) {
      if (ld_548 < 0.0 && MathAbs(ld_548) > Equity_Risk / 100.0 * AccountEquityHigh()) {
         CloseThisSymbolAll();
         Print("Trades will be closed because of excess equity");
         gi_356 = FALSE;
      }
   }
   gi_328 = CountTrades();
   if (gi_328 == 0) gi_292 = FALSE;
   for (g_pos_324 = OrdersTotal() - 1; g_pos_324 >= 0; g_pos_324--) {
      OrderSelect(g_pos_324, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_BUY) {
            gi_344 = TRUE;
            gi_348 = FALSE;
            ord_lots_500 = OrderLots();
            break;
         }
      }
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_SELL) {
            gi_344 = FALSE;
            gi_348 = TRUE;
            ord_lots_508 = OrderLots();
            break;
         }
      }
   }
   if (gi_328 > 0 && gi_328 <= Max_Trades) {
      RefreshRates();
      gd_268 = FindLastBuyPrice();
      gd_276 = FindLastSellPrice();
      if (gi_344 && gd_268 - Ask >= Pip_Step * gi_222 * Point) gi_340 = TRUE;
      if (gi_348 && Bid - gd_276 >= Pip_Step * gi_222 * Point) gi_340 = TRUE;
   }
   if (gi_328 < 1) {
      gi_348 = FALSE;
      gi_344 = FALSE;
      gi_340 = TRUE;
      gd_220 = AccountEquity();
   }
   if (gi_340) {
      gd_268 = FindLastBuyPrice();
      gd_276 = FindLastSellPrice();
      if (gi_348) {
         if (Close_On_Filters || ls_540 == "true") {
            fOrderCloseMarket(0, 1);
            gd_316 = NormalizeDouble(LotExponent * ord_lots_508, Lot_Type_0_1_2);
         } else gd_316 = fGetLots(OP_SELL);
         if (Multiplication_Lot && ls_532 == "true") {
            gi_312 = gi_328;
            if (gd_316 > 0.0) {
               RefreshRates();
               gi_352 = OpenPendingOrder(1, gd_316, Bid, Slippage * gi_222, Ask, 0, 0, The_Comment + "- " + gi_312, MagicNumber, 0, Red);
               if (gi_352 < 0) {
                  Print(" Correction of a mistake: ", ErrorDescription(GetLastError()));
                  return (0);
               }
               gd_276 = FindLastSellPrice();
               gi_340 = FALSE;
               gi_356 = TRUE;
            }
         }
         } else {
         if (gi_344) {
            if (Close_On_Filters || ls_540 == "true") {
               fOrderCloseMarket(1, 0);
               gd_316 = NormalizeDouble(LotExponent * ord_lots_500, Lot_Type_0_1_2);
            } else gd_316 = fGetLots(OP_BUY);
            if (Multiplication_Lot && ls_532 == "true") {
               gi_312 = gi_328;
               if (gd_316 > 0.0) {
                  gi_352 = OpenPendingOrder(0, gd_316, Ask, Slippage * gi_222, Bid, 0, 0, The_Comment + "- " + gi_312, MagicNumber, 0, Blue);
                  if (gi_352 < 0) {
                     Print(" Correction of a mistake: ", ErrorDescription(GetLastError()));
                     return (0);
                  }
                  gd_268 = FindLastBuyPrice();
                  gi_340 = FALSE;
                  gi_356 = TRUE;
               }
            }
         }
      }
   }
//==================================================================================================================================
  if (gi_340 && gi_328 < 1) {
      iclose_516 = iClose(Symbol(), 0, 2);
      iclose_524 = iClose(Symbol(), 0, 1);
      g_bid_252 = Bid;
      g_ask_260 = Ask;
      if ((!gi_348) && !gi_344 && ls_532 == "true") {
         gi_312 = gi_328;
         if (iclose_516 > iclose_524) {
            gd_316 = fGetLots(OP_SELL);
            if (gd_316 > 0.0) { // gd_316     OpenLotSize
               gi_352 = OpenPendingOrder(1, gd_316, g_bid_252, Slippage * gi_222, g_bid_252, 0, 0, The_Comment + "- " + gi_312, MagicNumber, 0, Red);
               if (gi_352 < 0) {
                  Print(gd_316, " Correction of a mistake: ", ErrorDescription(GetLastError()));
                  return (0);
               }
               gd_268 = FindLastBuyPrice();
               gi_356 = TRUE;
            }
         } 
//----------------------------------------------------------------------------------------------
         else {
            gd_316 = fGetLots(OP_BUY);
            if (gd_316 > 0.0) {
               gi_352 = OpenPendingOrder(0, gd_316, g_ask_260, Slippage * gi_222, g_ask_260, 0, 0, The_Comment + "- " + gi_312, MagicNumber, 0, Blue);
               if (gi_352 < 0) {
                  Print(gd_316, " Correction of a mistake: ", ErrorDescription(GetLastError()));
                  return (0);
               }
               gd_276 = FindLastSellPrice();
               gi_356 = TRUE;
            }
         }
      }
//==================================================================================================================================
      if (gi_352 > 0) gi_308 = TimeCurrent() + 60.0 * (60.0 * Timeout_hours);
      gi_340 = FALSE;
   }
   gi_328 = CountTrades();
   g_price_244 = 0;
   double ld_556 = 0;
   for (g_pos_324 = OrdersTotal() - 1; g_pos_324 >= 0; g_pos_324--) {
      OrderSelect(g_pos_324, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
            g_price_244 += OrderOpenPrice() * OrderLots();
            ld_556 += OrderLots();
         }
      }
   }
if (gi_328 > 0) g_price_244 = NormalizeDouble(g_price_244 / ld_556, Digits);
   if (gi_356) {
      for (g_pos_324 = OrdersTotal() - 1; g_pos_324 >= 0; g_pos_324--) {
         OrderSelect(g_pos_324, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() == OP_BUY) {
               g_price_212 = g_price_244 + TakeProfit * gi_222 * Point;
               gd_unused_228 = g_price_212;
               gd_332 = g_price_244 - StopLoss * gi_222 * Point;
               gi_292 = TRUE;
            }
         }
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() == OP_SELL) {
               g_price_212 = g_price_244 - TakeProfit * gi_222 * Point;
               gd_unused_236 = g_price_212;
               gd_332 = g_price_244 + StopLoss * gi_222 * Point;
               gi_292 = TRUE;
            }
         }
      }
   }
   if (gi_356) {
      if (gi_292 == TRUE) {
         for (g_pos_324 = OrdersTotal() - 1; g_pos_324 >= 0; g_pos_324--) {
            OrderSelect(g_pos_324, SELECT_BY_POS, MODE_TRADES);
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) OrderModify(OrderTicket(), g_price_244, OrderStopLoss(), g_price_212, 0, Yellow);
            gi_356 = FALSE;
         }
      }
   }
   return (0);
}
//==================================================================================================================================
double ND(double ad_0) {
   return (NormalizeDouble(ad_0, Digits));
}
//==================================================================================================================================
int fOrderCloseMarket(bool ai_0 = TRUE, bool ai_4 = TRUE) {
   int li_ret_8 = 0;
   for (int pos_12 = OrdersTotal() - 1; pos_12 >= 0; pos_12--) {
      if (OrderSelect(pos_12, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() == OP_BUY && ai_0) {
               RefreshRates();
               if (!IsTradeContextBusy()) {
                  if (!OrderClose(OrderTicket(), OrderLots(), ND(Bid), 5, CLR_NONE)) {
                     Print("Mistake of closing of Trade BUY " + OrderTicket());
                     li_ret_8 = -1;
                  }
               } else {
                  if (g_datetime_360 != iTime(NULL, 0, 0)) {
                     g_datetime_360 = iTime(NULL, 0, 0);
                     Print("Attempt of closing of Trade BUY " + OrderTicket() + ". The trading stream is borrowed");
                  }
                  return (-2);
               }
            }
            if (OrderType() == OP_SELL && ai_4) {
               RefreshRates();
               if (!IsTradeContextBusy()) {
                  if (!(!OrderClose(OrderTicket(), OrderLots(), ND(Ask), 5, CLR_NONE))) continue;
                  Print("Mistake of closing of Trade SELL " + OrderTicket());
                  li_ret_8 = -1;
                  continue;
               }
               if (g_datetime_364 != iTime(NULL, 0, 0)) {
                  g_datetime_364 = iTime(NULL, 0, 0);
                  Print("Attempt of closing of Trade SELL " + OrderTicket() + ". The trading stream is borrowed");
               }
               return (-2);
            }
         }
      }
   }
   return (li_ret_8);
}
//==================================================================================================================================
double fGetLots(int a_cmd_0) {
   double  lots_4;
   int     datetime_12;
   switch (Type_Average_lot) {
   case 0:
      lots_4 = Lot;
      break;
   case 1:
      lots_4 = NormalizeDouble(Lot * MathPow(LotExponent, gi_312), Lot_Type_0_1_2);
      break;
   case 2:
      datetime_12 = 0;
      lots_4 = Lot;
      for (int pos_20 = OrdersHistoryTotal() - 1; pos_20 >= 0; pos_20--) {
         if (OrderSelect(pos_20, SELECT_BY_POS, MODE_HISTORY)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
               if (datetime_12 < OrderCloseTime()) {
                  datetime_12 = OrderCloseTime();
                  if (OrderProfit() < 0.0) {
                     lots_4 = NormalizeDouble(OrderLots() * LotExponent, Lot_Type_0_1_2);
                     continue;
                  }
                  lots_4 = Lot;
               }
            }
         } else return (-3);
      }
   }
   if (AccountFreeMarginCheck(Symbol(), a_cmd_0, lots_4) <= 0.0) return (-1);
   if (GetLastError() == 134/* NOT_ENOUGH_MONEY */) return (-2);
   return (lots_4);
}
//==================================================================================================================================
int CountTrades() {
   int count_0 = 0;
   for (int pos_4 = OrdersTotal() - 1; pos_4 >= 0; pos_4--) {
      OrderSelect(pos_4, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         if (OrderType() == OP_SELL || OrderType() == OP_BUY) count_0++;
   }
   return (count_0);
}
//==================================================================================================================================
void CloseThisSymbolAll() {
   for (int pos_0 = OrdersTotal() - 1; pos_0 >= 0; pos_0--) {
      OrderSelect(pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() ==  OP_BUY) OrderClose(OrderTicket(), OrderLots(), Bid, Slippage * gi_222, Blue);
            if (OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), Ask, Slippage * gi_222, Red);
         }
         Sleep(1000);
      }
   }
}
//==================================================================================================================================
int OpenPendingOrder(int ai_0, double a_lots_4, double a_price_12, int a_slippage_20, double ad_24, int ai_unused_32, int ai_36, string a_comment_40, int a_magic_48, int a_datetime_52, color a_color_56) {
   int ticket_60 =   0;
   int error_64  =   0;
   int count_68  =   0;
   int li_72     = 100;
   switch (ai_0) {
   case 2:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_BUYLIMIT, a_lots_4, a_price_12, a_slippage_20, StopLong(ad_24, StopLoss * gi_222), TakeLong(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(1000);
      }
      break;
   case 4:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_BUYSTOP, a_lots_4, a_price_12, a_slippage_20, StopLong(ad_24, StopLoss * gi_222), TakeLong(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 0:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         RefreshRates();
         ticket_60 = OrderSend(Symbol(), OP_BUY, a_lots_4, Ask, a_slippage_20, StopLong(Bid, StopLoss * gi_222), TakeLong(Ask, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 3:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_SELLLIMIT, a_lots_4, a_price_12, a_slippage_20, StopShort(ad_24, StopLoss * gi_222), TakeShort(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 5:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_SELLSTOP, a_lots_4, a_price_12, a_slippage_20, StopShort(ad_24, StopLoss * gi_222), TakeShort(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 1:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_SELL, a_lots_4, Bid, a_slippage_20, StopShort(Ask, StopLoss * gi_222), TakeShort(Bid, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
   }
   return (ticket_60);
}
//==================================================================================================================================
double StopLong(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 - ai_8 * Point);
}
//==================================================================================================================================
double StopShort(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 + ai_8 * Point);
}
//==================================================================================================================================
double TakeLong(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 + ai_8 * Point);
}
//==================================================================================================================================
double TakeShort(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 - ai_8 * Point);
}
//==================================================================================================================================
double CalculateProfit() {
   double ld_ret_0 = 0;
   for (g_pos_324 = OrdersTotal() - 1; g_pos_324 >= 0; g_pos_324--) {
      OrderSelect(g_pos_324, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) ld_ret_0 += OrderProfit();
   }
   return (ld_ret_0);
}
//==================================================================================================================================
double AccountEquityHigh() {
   if (CountTrades() == 0) gd_368 = AccountEquity();
   if (gd_368 < gd_376) gd_368 = gd_376;
   else gd_368 = AccountEquity();
   gd_376 = AccountEquity();
   return (gd_368);
}
//==================================================================================================================================
double FindLastBuyPrice() {
   double ord_open_price_0;
   int    ticket_8;
   double ld_unused_12 = 0;
   int    ticket_20 = 0;
   for (int pos_24 = OrdersTotal() - 1; pos_24 >= 0; pos_24--) {
      OrderSelect(pos_24, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY) {
         ticket_8 = OrderTicket();
         if (ticket_8 > ticket_20) {
            ord_open_price_0 = OrderOpenPrice();
            ld_unused_12 = ord_open_price_0;
            ticket_20 = ticket_8;
         }
      }
   }
   return (ord_open_price_0);
}
//==================================================================================================================================
double FindLastSellPrice() {
   double ord_open_price_0;
   int    ticket_8;
   double ld_unused_12 = 0;
   int    ticket_20    = 0;
   for (int pos_24 = OrdersTotal() - 1; pos_24 >= 0; pos_24--) {
      OrderSelect(pos_24, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) {
         ticket_8 = OrderTicket();
         if (ticket_8 > ticket_20) {
            ord_open_price_0 = OrderOpenPrice();
            ld_unused_12 = ord_open_price_0;
            ticket_20 = ticket_8;
         }
      }
   }
   return (ord_open_price_0);
}
//==================================================================================================================================
void Display_Info() {  // Conclusion of the information in angle of a window
    Comment(
      "\n", "                              Account Name:     " + AccountName(),
      "\n", "                              Broker Name:     " + AccountCompany(),
      "\n", "                              Server:  ", AccountServer(),
      "\n", "                              Account Number:     " + DoubleToStr(AccountNumber(),0),
      "\n", "                              Slippage  =  ", Slippage,
      "\n", "                              Account Profit:     " + DoubleToStr(AccountProfit(),0),
      "\n", "                              Account Leverage:     ","1:" + DoubleToStr(AccountLeverage(), 0),
      "\n", "                              Account Balance:     " + DoubleToStr(AccountBalance(), 0),
      "\n", "                              Account Equity:     " + DoubleToStr(AccountEquity(), 0),
      "\n", "                              Free Margin:     " + DoubleToStr(AccountFreeMargin(), 0),
      "\n", "                              Used Margin:     " + DoubleToStr(AccountMargin(), 0),
      "\n", "                              Stop Out Level:     " + DoubleToStr(AccountStopoutLevel(), 0),
      "\n", "                              Date:     " + TimeToStr(TimeCurrent(),TIME_DATE),
      "\n", "                              Broker Server Time:     " + TimeToStr(TimeCurrent(),TIME_SECONDS),
      "\n", "                              Computer Local Time:     " + TimeToStr(TimeLocal(),TIME_SECONDS),
 
      
  "\n");
}
//==================================================================================================================================
//| ErrorDescription. Returns the description of a mistake under its number.
//+---------------------------------------------------------------------------------------------------------------------------------
string ErrorDescription(int error) {
   string ErrorNumber;
   switch (error) {
   case 0:
   case 1:     ErrorNumber = "The mistake is corrected";                                                    break;  
   case 2:     ErrorNumber = "The general mistake";                                                         break;
   case 3:     ErrorNumber = "Wrong parameters";                                                            break;
   case 4:     ErrorNumber = "The trading server is borrowed";                                              break;
   case 5:     ErrorNumber = "The old version of the client terminal";                                      break;
   case 6:     ErrorNumber = "There is no communication with a trading server";                             break;
   case 7:     ErrorNumber = "It is insufficiently right";                                                  break;
   case 8:     ErrorNumber = "Too frequent inquiries";                                                      break;
   case 9:     ErrorNumber = "Inadmissible operation breaking functioning of a server";                     break;
   case 64:    ErrorNumber = "The account is blocked";                                                      break;
   case 65:    ErrorNumber = "Wrong number of the account";                                                 break;
   case 128:   ErrorNumber = "Has expired timeframe of expectation of settlement of a transaction";                      break;
   case 129:   ErrorNumber = "The wrong price";                                                             break;
   case 130:   ErrorNumber = "Wrong stops";                                                                 break;
   case 131:   ErrorNumber = "Wrong volume";                                                                break;
   case 132:   ErrorNumber = "The market is closed";                                                        break;
   case 133:   ErrorNumber = "Trade is forbidden";                                                          break;
   case 134:   ErrorNumber = "There is not enough money for fulfilment of operation";                       break;
   case 135:   ErrorNumber = "The price has changed";                                                       break;
   case 136:   ErrorNumber = "There are no prices";                                                         break;
   case 137:   ErrorNumber = "The broker is borrowed";                                                      break;
   case 138:   ErrorNumber = "New Prices";                                                                  break;
   case 139:   ErrorNumber = "The warrant is blocked and already processed";                                break;
   case 140:   ErrorNumber = "Purchase is resolved only";                                                   break;
   case 141:   ErrorNumber = "It is too much inquiries";                                                    break;
   case 145:   ErrorNumber = "Modification is forbidden, as the warrant is too close to the market";        break;
   case 146:   ErrorNumber = "The subsystem of Trade is borrowed";                                          break;
   case 147:   ErrorNumber = "Use of date of the expiration of the warrant is forbidden by the broker";     break;
   case 148:   ErrorNumber = "The quantity of the open and postponed warrants has reached a limit ";        break;
//-----------------------------------------------------------------------------------------------
   case 4000:  ErrorNumber = "There is no mistake";                                                         break;
   case 4001:  ErrorNumber = "The wrong index of function";                                                 break;
   case 4002:  ErrorNumber = "Index of a file out-of-range";                                                break;
   case 4003:  ErrorNumber = "There is no memory for a stack of functions";                                 break;
   case 4004:  ErrorNumber = "Overflow of a stack after a recursive call";                                  break;
   case 4005:  ErrorNumber = "On a stack there is no memory for transfer of parameters";                    break;
   case 4006:  ErrorNumber = "There is no memory for line parameter";                                       break;
   case 4007:  ErrorNumber = "There is no memory for a temporary line";                                     break;
   case 4008:  ErrorNumber = "Not initialized line";                                                        break;
   case 4009:  ErrorNumber = "Not initialized line in a file";                                              break;
   case 4010:  ErrorNumber = "There is no memory for a line file";                                          break;
   case 4011:  ErrorNumber = "Too long line";                                                               break;
   case 4012:  ErrorNumber = "Remainder of division on a zero";                                             break;
   case 4013:  ErrorNumber = "Division into a zero";                                                        break;
   case 4014:  ErrorNumber = "Unknown command";                                                             break;
   case 4015:  ErrorNumber = "Wrong transition";                                                            break;
   case 4016:  ErrorNumber = "Not initialized file";                                                        break;
   case 4017:  ErrorNumber = "Calls DLL are not resolved";                                                  break;
   case 4018:  ErrorNumber = "It is impossible to load library";                                            break;
   case 4019:  ErrorNumber = "It is impossible to cause function";                                          break;
   case 4020:  ErrorNumber = "Calls of external library functions are not resolved";                        break;
   case 4021:  ErrorNumber = "There is not enough memory for a line returned from function";                break;
   case 4022:  ErrorNumber = "The system is borrowed";                                                      break;
   case 4050:  ErrorNumber = "Wrong quantity of parameters of function";                                    break;
   case 4051:  ErrorNumber = "Inadmissible value of parameter of function";                                 break;
   case 4052:  ErrorNumber = "Internal mistake of line function";                                           break;
   case 4053:  ErrorNumber = "Mistake of a file";                                                           break;
   case 4054:  ErrorNumber = "  -";                                break;
   case 4055:  ErrorNumber = "Mistake of the user indicator";                                               break;
   case 4056:  ErrorNumber = "Files are incompatible";                                                      break;
   case 4057:  ErrorNumber = "Mistake of processing Global variables";                                      break;
   case 4058:  ErrorNumber = "The global variable is not detected";                                         break;
   case 4059:  ErrorNumber = "Function is not resolved in a test mode";                                     break;
   case 4060:  ErrorNumber = "Function is not confirmed";                                                   break;
   case 4061:  ErrorNumber = "Mistake of sending of mail";                                                  break;
   case 4062:  ErrorNumber = "The parameter of type string is expected";                                    break;
   case 4063:  ErrorNumber = "The parameter of type integer is expected";                                   break;
   case 4064:  ErrorNumber = "Gide parameter of type double";                                              break;
   case 4065:  ErrorNumber = "As parameter the file is expected";                                           break;
   case 4066:  ErrorNumber = "The requested historical updatings given in a condition";                     break;
   case 4067:  ErrorNumber = "Mistake at performance of trading operation";                                 break;
   case 4099:  ErrorNumber = "The end of a file";                                                           break;
   case 4100:  ErrorNumber = "Mistake at work on a file";                                                   break;
   case 4101:  ErrorNumber = "Wrong name of a file";                                                        break;
   case 4102:  ErrorNumber = "Too many the open files";                                                     break;
   case 4103:  ErrorNumber = "It is impossible to open a file";                                             break;
   case 4104:  ErrorNumber = "Incompatible mode of access to a file";                                       break;
   case 4105:  ErrorNumber = "Any warrant is not chosen";                                                   break;
   case 4106:  ErrorNumber = "Unknown symbol";                                                              break;
   case 4107:  ErrorNumber = "Wrong parameter of the price for trading function";                           break;
   case 4108:  ErrorNumber = "Incorrect number ticket";                                                     break;
   case 4109:  ErrorNumber = "Trades is not resolved";                                                      break;
   case 4110:  ErrorNumber = "Long positions are not resolved";                                             break;
   case 4111:  ErrorNumber = "Short positions are not resolved";                                            break;
   case 4200:  ErrorNumber = "The object already exists";                                                   break;
   case 4201:  ErrorNumber = "Unknown property of object is requested";                                     break;
   case 4202:  ErrorNumber = "The object does not exist";                                                   break;
   case 4203:  ErrorNumber = "Unknown type of object";                                                      break;
   case 4204:  ErrorNumber = "There is no name of object";                                                  break;
   case 4205:  ErrorNumber = "Mistake of coordinates of object";                                            break;
   case 4206:  ErrorNumber = "It is not found specified pane";                                              break;
   case 4207:  ErrorNumber = "Mistake at work on object";                                                   break;
   default:    ErrorNumber = "Unknown mistake";
   }
   return (ErrorNumber);
}
//==================================================================================================================================
double GetProfitForDay(int ai_01) {
   double ld_ret_4 = 0;
   for (int l_pos_12 = 0; l_pos_12 < OrdersHistoryTotal(); l_pos_12++) {
      if (!(OrderSelect(l_pos_12, SELECT_BY_POS, MODE_HISTORY))) break;
      if (OrderSymbol() == Symbol())
         if (OrderCloseTime() >= iTime(Symbol(), PERIOD_D1, ai_01) && OrderCloseTime() < iTime(Symbol(), PERIOD_D1, ai_01) + 86400) ld_ret_4 += OrderProfit() + OrderSwap() + OrderCommission();
   }
   return (ld_ret_4);
}

//==================================================================================================================================
void DrawStats() {
   double ld_0 = GetProfitForDay(0);
   string l_name_8 = gs_140 + "1";
   if (ObjectFind  (l_name_8) == -1) {
       //ObjectCreate(l_name_8, OBJ_LABEL, 0, 0, 0);
       ObjectSet   (l_name_8, OBJPROP_CORNER, 1);
       ObjectSet   (l_name_8, OBJPROP_XDISTANCE, 10);
       ObjectSet   (l_name_8, OBJPROP_YDISTANCE, 15);
   }
  }
  
 